#include <bits/stdc++.h>
using namespace std;
#define int long long

const int N = 1e5 + 5;
const int C = 50;
const int MOD = 1e9 + 7;

int sum (int a, int b) {
    a += b;
    return (a >= MOD ? a - MOD : a);
}

int sub (int a, int b) {
    a -= b;
    return (a < 0 ? a + MOD : a);
}

int mul (int a, int b) {
    return a * b % MOD;
}



void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> b(n);
    for (auto &x : b)
        cin >> x;

    if (k == 1) {
        cout << "1\n";
        return;
    }
   vector<vector<int>> dp(n, vector<int>(C));
    for (int i = 0; i < min(b[0] + 1, C); ++i) {
        for (int j = 0; j < min(b[0] + 1, C); ++j) {
            if (i + j == b[0]) {
                dp[0][i] = sum(dp[0][i], 1);
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < min(C, b[i] + 1); ++j) {
            for (int z = 0; z < min(C, b[i] + 1); ++z) {
                for (int r = 0; r < min(C, b[i] + 1); ++r) {
                    if (r + z + j == b[i]) {
                        dp[i][j] = sum(dp[i][j], dp[i - 1][z]);
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < C; ++i) ans = sum(ans, dp[n - 1][i]);
    cout << ans << '\n';

}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
